#include <iostream>
#include <vector>
#include <map>
#include <string>

using namespace std;

#include <TTree.h>
#include <TString.h>
#include <TPad.h>
#include <TCanvas.h>
#include <TVirtualPad.h>
#include <TCut.h>

extern map<TString, TTree *> g_myTreeMap;
extern map<TString, TObject *> g_myHistosMap;
extern vector<TString> g_histosOrder;

// defs
class OnCanvasOptions {
 public:
  OnCanvasOptions(){};
  virtual ~OnCanvasOptions(){};
  bool doLegend;
  TString constructorStr;
  TString drawOpt;
  Int_t markerStyle;
  Bool_t setLogY;
  Bool_t drawNormalized;
  Bool_t orderHistos;
  ClassDef(OnCanvasOptions, 1)
};

class ActionFlags {
 public:
  ActionFlags(){};
  ~ActionFlags(){};
  bool doIntegral;
};

// prototypes
void GetTree(TString, TString, TString, double);
void GetTree(TTree *, TString, double);
TTree * GetTreePtr(TString);
map<TString, TObject *> GetHistosMap();
TObject * DrawAll(TString, TCut, OnCanvasOptions &, ActionFlags);
void TreeFillMap(TString, TTree *);
int NOfColons(const char *);
int GetNHistos(TString);
TString GetHistoKey(int, TString);
TObject * GetHistoPtr(int, TString);
